import{s as xa,f as at,n as _a,o as Ma}from"../chunks/scheduler.37c15a92.js";import{S as Ta,i as ka,g as i,s as n,r as rt,m as r,H as g,A as $a,h as p,f as s,c as l,j as w,u as ot,x as o,n as c,B as u,k as h,y as m,a as e,v as ct,d as ht,t as gt,w as ut}from"../chunks/index.7cb9c9b8.js";import{H as wt,E as Pa}from"../chunks/EditOnGithub.858acfec.js";function Ca(Ss){let y,yt,ft,bt,$,xt,P,_t,C,Gs="Let’s remember what the objective is to optimize in Reinforce:",Mt,L,qs,Tt,j,Fs="The idea was that by taking a gradient ascent step on this function (equivalent to taking gradient descent of the negative of this function), we would <strong>push our agent to take actions that lead to higher rewards and avoid harmful actions.</strong>",kt,z,As="However, the problem comes from the step size:",$t,H,Us="<li>Too small, <strong>the training process was too slow</strong></li> <li>Too high, <strong>there was too much variability in the training</strong></li>",Pt,O,Bs="With PPO, the idea is to constrain our policy update with a new objective function called the <em>Clipped surrogate objective function</em> that <strong>will constrain the policy change in a small range using a clip.</strong>",Ct,I,Ws="This new function <strong>is designed to avoid destructively large weights updates</strong> :",Lt,E,Ns,jt,R,Ks="Let’s study each part to understand how it works.",zt,S,Ht,G,Ds,Ot,q,Js="This ratio is calculated as follows:",It,F,Qs,Et,f,Cs,Rt,oa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>a</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> a_t </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">a</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',St,Gt,ca='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>s</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> s_t </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',qt,Ft,_,Ls,At,ha='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>r</mi><mi>t</mi></msub><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> r_t(\\theta) </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0278em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Ut,Bt,M,T,js,Wt,ga='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>r</mi><mi>t</mi></msub><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo><mo>&gt;</mo><mn>1</mn></mrow><annotation encoding="application/x-tex"> r_t(\\theta) &gt; 1 </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0278em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">&gt;</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">1</span></span></span></span>',Nt,b,zs,Kt,ua='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>a</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> a_t </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">a</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Dt,Jt,fa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>s</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> s_t </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Qt,Hs,x,Os,Vt,va='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>r</mi><mi>t</mi></msub><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> r_t(\\theta) </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0278em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Xt,et,Vs="action is less likely for the current policy than for the old one",Is,Yt,A,Xs="So this probability ratio is an <strong>easy way to estimate the divergence between old and current policy.</strong>",Zt,U,ts,B,Ys,ss,W,Zs="This ratio <strong>can replace the log probability we use in the policy objective function</strong>. This gives us the left part of the new objective function: multiplying the ratio by the advantage.",as,k,ta='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/unclipped2.jpg" alt="PPO"/> <figcaption><a href="https://arxiv.org/pdf/1707.06347.pdf">Proximal Policy Optimization Algorithms</a></figcaption>',es,N,sa="However, without a constraint, if the action taken is much more probable in our current policy than in our former, <strong>this would lead to a significant policy gradient step</strong> and, therefore, an <strong>excessive policy update.</strong>",ns,K,ls,D,aa,is,J,ea="Consequently, we need to constrain this objective function by penalizing changes that lead to a ratio far away from 1 (in the paper, the ratio can only vary from 0.8 to 1.2).",ps,Q,na="<strong>By clipping the ratio, we ensure that we do not have a too large policy update because the current policy can’t be too different from the older one.</strong>",ms,V,la="To do that, we have two solutions:",rs,X,ia="<li><em>TRPO (Trust Region Policy Optimization)</em> uses KL divergence constraints outside the objective function to constrain the policy update. But this method <strong>is complicated to implement and takes more computation time.</strong></li> <li><em>PPO</em> clip probability ratio directly in the objective function with its <strong>Clipped surrogate objective function.</strong></li>",os,Y,pa,cs,v,Es,hs,da='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>r</mi><mi>t</mi></msub><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> r_t(\\theta) </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0278em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',gs,us,wa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo separator="true">,</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon, 1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8389em;vertical-align:-0.1944em;"></span><span class="mord mathnormal">ϵ</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',fs,vs,d,Rs,ds,ya='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo separator="true">,</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon, 1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8389em;vertical-align:-0.1944em;"></span><span class="mord mathnormal">ϵ</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',ws,ys,ba='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>ϵ</mi><mo>=</mo><mn>0.2</mn></mrow><annotation encoding="application/x-tex"> \\epsilon = 0.2 </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal">ϵ</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">0.2</span></span></span></span>',bs,xs,Z,ma="Then, we take the minimum of the clipped and non-clipped objective, <strong>so the final objective is a lower bound (pessimistic bound) of the unclipped objective.</strong>",_s,tt,ra="Taking the minimum of the clipped and non-clipped objective means <strong>we’ll select either the clipped or the non-clipped objective based on the ratio and advantage situation</strong>.",Ms,st,Ts,vt,ks;return $=new wt({props:{title:"Introducing the Clipped Surrogate Objective Function",local:"introducing-the-clipped-surrogate-objective-function",headingTag:"h1"}}),P=new wt({props:{title:"Recap: The Policy Objective Function",local:"recap-the-policy-objective-function",headingTag:"h2"}}),S=new wt({props:{title:"The Ratio Function",local:"the-ratio-function",headingTag:"h2"}}),U=new wt({props:{title:"The unclipped part of the Clipped Surrogate Objective function",local:"the-unclipped-part-of-the-clipped-surrogate-objective-function",headingTag:"h2"}}),K=new wt({props:{title:"The clipped Part of the Clipped Surrogate Objective function",local:"the-clipped-part-of-the-clipped-surrogate-objective-function",headingTag:"h2"}}),st=new Pa({props:{source:"https://github.com/huggingface/deep-rl-class/blob/main/units/en/unit8/clipped-surrogate-objective.mdx"}}),{c(){y=i("meta"),yt=n(),ft=i("p"),bt=n(),rt($.$$.fragment),xt=n(),rt(P.$$.fragment),_t=n(),C=i("p"),C.textContent=Gs,Mt=n(),L=i("img"),Tt=n(),j=i("p"),j.innerHTML=Fs,kt=n(),z=i("p"),z.textContent=As,$t=n(),H=i("ul"),H.innerHTML=Us,Pt=n(),O=i("p"),O.innerHTML=Bs,Ct=n(),I=i("p"),I.innerHTML=Ws,Lt=n(),E=i("img"),jt=n(),R=i("p"),R.textContent=Ks,zt=n(),rt(S.$$.fragment),Ht=n(),G=i("img"),Ot=n(),q=i("p"),q.textContent=Js,It=n(),F=i("img"),Et=n(),f=i("p"),Cs=r("It’s the probability of taking action"),Rt=new g(!1),St=r(" at state"),Gt=new g(!1),qt=r(" in the current policy, divided by the same for the previous policy."),Ft=n(),_=i("p"),Ls=r("As we can see,"),At=new g(!1),Ut=r(" denotes the probability ratio between the current and old policy:"),Bt=n(),M=i("ul"),T=i("li"),js=r("If"),Wt=new g(!1),Nt=r(", the "),b=i("strong"),zs=r("action"),Kt=new g(!1),Dt=r(" at state"),Jt=new g(!1),Qt=r(" is more likely in the current policy than the old policy."),Hs=n(),x=i("li"),Os=r("If"),Vt=new g(!1),Xt=r(" is between 0 and 1, the "),et=i("strong"),et.textContent=Vs,Is=r("."),Yt=n(),A=i("p"),A.innerHTML=Xs,Zt=n(),rt(U.$$.fragment),ts=n(),B=i("img"),ss=n(),W=i("p"),W.innerHTML=Zs,as=n(),k=i("figure"),k.innerHTML=ta,es=n(),N=i("p"),N.innerHTML=sa,ns=n(),rt(K.$$.fragment),ls=n(),D=i("img"),is=n(),J=i("p"),J.textContent=ea,ps=n(),Q=i("p"),Q.innerHTML=na,ms=n(),V=i("p"),V.textContent=la,rs=n(),X=i("ul"),X.innerHTML=ia,os=n(),Y=i("img"),cs=n(),v=i("p"),Es=r("This clipped part is a version where"),hs=new g(!1),gs=r(" is clipped between "),us=new g(!1),fs=r("."),vs=n(),d=i("p"),Rs=r("With the Clipped Surrogate Objective function, we have two probability ratios, one non-clipped and one clipped in a range between "),ds=new g(!1),ws=r(", epsilon is a hyperparameter that helps us to define this clip range (in the paper "),ys=new g(!1),bs=r(".)."),xs=n(),Z=i("p"),Z.innerHTML=ma,_s=n(),tt=i("p"),tt.innerHTML=ra,Ms=n(),rt(st.$$.fragment),Ts=n(),vt=i("p"),this.h()},l(t){const a=$a("svelte-u9bgzb",document.head);y=p(a,"META",{name:!0,content:!0}),a.forEach(s),yt=l(t),ft=p(t,"P",{}),w(ft).forEach(s),bt=l(t),ot($.$$.fragment,t),xt=l(t),ot(P.$$.fragment,t),_t=l(t),C=p(t,"P",{"data-svelte-h":!0}),o(C)!=="svelte-1jx0086"&&(C.textContent=Gs),Mt=l(t),L=p(t,"IMG",{src:!0,alt:!0}),Tt=l(t),j=p(t,"P",{"data-svelte-h":!0}),o(j)!=="svelte-1wz1mni"&&(j.innerHTML=Fs),kt=l(t),z=p(t,"P",{"data-svelte-h":!0}),o(z)!=="svelte-70fob"&&(z.textContent=As),$t=l(t),H=p(t,"UL",{"data-svelte-h":!0}),o(H)!=="svelte-9oh9id"&&(H.innerHTML=Us),Pt=l(t),O=p(t,"P",{"data-svelte-h":!0}),o(O)!=="svelte-mlpukg"&&(O.innerHTML=Bs),Ct=l(t),I=p(t,"P",{"data-svelte-h":!0}),o(I)!=="svelte-1tgcet3"&&(I.innerHTML=Ws),Lt=l(t),E=p(t,"IMG",{src:!0,alt:!0}),jt=l(t),R=p(t,"P",{"data-svelte-h":!0}),o(R)!=="svelte-pc0b8m"&&(R.textContent=Ks),zt=l(t),ot(S.$$.fragment,t),Ht=l(t),G=p(t,"IMG",{src:!0,alt:!0}),Ot=l(t),q=p(t,"P",{"data-svelte-h":!0}),o(q)!=="svelte-1sbo9d1"&&(q.textContent=Js),It=l(t),F=p(t,"IMG",{src:!0,alt:!0}),Et=l(t),f=p(t,"P",{});var nt=w(f);Cs=c(nt,"It’s the probability of taking action"),Rt=u(nt,!1),St=c(nt," at state"),Gt=u(nt,!1),qt=c(nt," in the current policy, divided by the same for the previous policy."),nt.forEach(s),Ft=l(t),_=p(t,"P",{});var $s=w(_);Ls=c($s,"As we can see,"),At=u($s,!1),Ut=c($s," denotes the probability ratio between the current and old policy:"),$s.forEach(s),Bt=l(t),M=p(t,"UL",{});var Ps=w(M);T=p(Ps,"LI",{});var dt=w(T);js=c(dt,"If"),Wt=u(dt,!1),Nt=c(dt,", the "),b=p(dt,"STRONG",{});var lt=w(b);zs=c(lt,"action"),Kt=u(lt,!1),Dt=c(lt," at state"),Jt=u(lt,!1),Qt=c(lt," is more likely in the current policy than the old policy."),lt.forEach(s),dt.forEach(s),Hs=l(Ps),x=p(Ps,"LI",{});var it=w(x);Os=c(it,"If"),Vt=u(it,!1),Xt=c(it," is between 0 and 1, the "),et=p(it,"STRONG",{"data-svelte-h":!0}),o(et)!=="svelte-sxr5di"&&(et.textContent=Vs),Is=c(it,"."),it.forEach(s),Ps.forEach(s),Yt=l(t),A=p(t,"P",{"data-svelte-h":!0}),o(A)!=="svelte-m31yz6"&&(A.innerHTML=Xs),Zt=l(t),ot(U.$$.fragment,t),ts=l(t),B=p(t,"IMG",{src:!0,alt:!0}),ss=l(t),W=p(t,"P",{"data-svelte-h":!0}),o(W)!=="svelte-zxswmp"&&(W.innerHTML=Zs),as=l(t),k=p(t,"FIGURE",{class:!0,"data-svelte-h":!0}),o(k)!=="svelte-13ku1ey"&&(k.innerHTML=ta),es=l(t),N=p(t,"P",{"data-svelte-h":!0}),o(N)!=="svelte-1e78bt7"&&(N.innerHTML=sa),ns=l(t),ot(K.$$.fragment,t),ls=l(t),D=p(t,"IMG",{src:!0,alt:!0}),is=l(t),J=p(t,"P",{"data-svelte-h":!0}),o(J)!=="svelte-cpftrh"&&(J.textContent=ea),ps=l(t),Q=p(t,"P",{"data-svelte-h":!0}),o(Q)!=="svelte-1iqqwcw"&&(Q.innerHTML=na),ms=l(t),V=p(t,"P",{"data-svelte-h":!0}),o(V)!=="svelte-aufndz"&&(V.textContent=la),rs=l(t),X=p(t,"UL",{"data-svelte-h":!0}),o(X)!=="svelte-5n19r6"&&(X.innerHTML=ia),os=l(t),Y=p(t,"IMG",{src:!0,alt:!0}),cs=l(t),v=p(t,"P",{});var pt=w(v);Es=c(pt,"This clipped part is a version where"),hs=u(pt,!1),gs=c(pt," is clipped between "),us=u(pt,!1),fs=c(pt,"."),pt.forEach(s),vs=l(t),d=p(t,"P",{});var mt=w(d);Rs=c(mt,"With the Clipped Surrogate Objective function, we have two probability ratios, one non-clipped and one clipped in a range between "),ds=u(mt,!1),ws=c(mt,", epsilon is a hyperparameter that helps us to define this clip range (in the paper "),ys=u(mt,!1),bs=c(mt,".)."),mt.forEach(s),xs=l(t),Z=p(t,"P",{"data-svelte-h":!0}),o(Z)!=="svelte-eqkgrh"&&(Z.innerHTML=ma),_s=l(t),tt=p(t,"P",{"data-svelte-h":!0}),o(tt)!=="svelte-1k9oa10"&&(tt.innerHTML=ra),Ms=l(t),ot(st.$$.fragment,t),Ts=l(t),vt=p(t,"P",{}),w(vt).forEach(s),this.h()},h(){h(y,"name","hf:doc:metadata"),h(y,"content",La),at(L.src,qs="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/lpg.jpg")||h(L,"src",qs),h(L,"alt","Reinforce"),at(E.src,Ns="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/ppo-surrogate.jpg")||h(E,"src",Ns),h(E,"alt","PPO surrogate function"),at(G.src,Ds="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/ratio1.jpg")||h(G,"src",Ds),h(G,"alt","Ratio"),at(F.src,Qs="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/ratio2.jpg")||h(F,"src",Qs),h(F,"alt","Ratio"),Rt.a=St,Gt.a=qt,At.a=Ut,Wt.a=Nt,Kt.a=Dt,Jt.a=Qt,Vt.a=Xt,at(B.src,Ys="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/unclipped1.jpg")||h(B,"src",Ys),h(B,"alt","PPO"),h(k,"class","image table text-center m-0 w-full"),at(D.src,aa="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/clipped.jpg")||h(D,"src",aa),h(D,"alt","PPO"),at(Y.src,pa="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/clipped.jpg")||h(Y,"src",pa),h(Y,"alt","PPO"),hs.a=gs,us.a=fs,ds.a=ws,ys.a=bs},m(t,a){m(document.head,y),e(t,yt,a),e(t,ft,a),e(t,bt,a),ct($,t,a),e(t,xt,a),ct(P,t,a),e(t,_t,a),e(t,C,a),e(t,Mt,a),e(t,L,a),e(t,Tt,a),e(t,j,a),e(t,kt,a),e(t,z,a),e(t,$t,a),e(t,H,a),e(t,Pt,a),e(t,O,a),e(t,Ct,a),e(t,I,a),e(t,Lt,a),e(t,E,a),e(t,jt,a),e(t,R,a),e(t,zt,a),ct(S,t,a),e(t,Ht,a),e(t,G,a),e(t,Ot,a),e(t,q,a),e(t,It,a),e(t,F,a),e(t,Et,a),e(t,f,a),m(f,Cs),Rt.m(oa,f),m(f,St),Gt.m(ca,f),m(f,qt),e(t,Ft,a),e(t,_,a),m(_,Ls),At.m(ha,_),m(_,Ut),e(t,Bt,a),e(t,M,a),m(M,T),m(T,js),Wt.m(ga,T),m(T,Nt),m(T,b),m(b,zs),Kt.m(ua,b),m(b,Dt),Jt.m(fa,b),m(b,Qt),m(M,Hs),m(M,x),m(x,Os),Vt.m(va,x),m(x,Xt),m(x,et),m(x,Is),e(t,Yt,a),e(t,A,a),e(t,Zt,a),ct(U,t,a),e(t,ts,a),e(t,B,a),e(t,ss,a),e(t,W,a),e(t,as,a),e(t,k,a),e(t,es,a),e(t,N,a),e(t,ns,a),ct(K,t,a),e(t,ls,a),e(t,D,a),e(t,is,a),e(t,J,a),e(t,ps,a),e(t,Q,a),e(t,ms,a),e(t,V,a),e(t,rs,a),e(t,X,a),e(t,os,a),e(t,Y,a),e(t,cs,a),e(t,v,a),m(v,Es),hs.m(da,v),m(v,gs),us.m(wa,v),m(v,fs),e(t,vs,a),e(t,d,a),m(d,Rs),ds.m(ya,d),m(d,ws),ys.m(ba,d),m(d,bs),e(t,xs,a),e(t,Z,a),e(t,_s,a),e(t,tt,a),e(t,Ms,a),ct(st,t,a),e(t,Ts,a),e(t,vt,a),ks=!0},p:_a,i(t){ks||(ht($.$$.fragment,t),ht(P.$$.fragment,t),ht(S.$$.fragment,t),ht(U.$$.fragment,t),ht(K.$$.fragment,t),ht(st.$$.fragment,t),ks=!0)},o(t){gt($.$$.fragment,t),gt(P.$$.fragment,t),gt(S.$$.fragment,t),gt(U.$$.fragment,t),gt(K.$$.fragment,t),gt(st.$$.fragment,t),ks=!1},d(t){t&&(s(yt),s(ft),s(bt),s(xt),s(_t),s(C),s(Mt),s(L),s(Tt),s(j),s(kt),s(z),s($t),s(H),s(Pt),s(O),s(Ct),s(I),s(Lt),s(E),s(jt),s(R),s(zt),s(Ht),s(G),s(Ot),s(q),s(It),s(F),s(Et),s(f),s(Ft),s(_),s(Bt),s(M),s(Yt),s(A),s(Zt),s(ts),s(B),s(ss),s(W),s(as),s(k),s(es),s(N),s(ns),s(ls),s(D),s(is),s(J),s(ps),s(Q),s(ms),s(V),s(rs),s(X),s(os),s(Y),s(cs),s(v),s(vs),s(d),s(xs),s(Z),s(_s),s(tt),s(Ms),s(Ts),s(vt)),s(y),ut($,t),ut(P,t),ut(S,t),ut(U,t),ut(K,t),ut(st,t)}}}const La='{"title":"Introducing the Clipped Surrogate Objective Function","local":"introducing-the-clipped-surrogate-objective-function","sections":[{"title":"Recap: The Policy Objective Function","local":"recap-the-policy-objective-function","sections":[],"depth":2},{"title":"The Ratio Function","local":"the-ratio-function","sections":[],"depth":2},{"title":"The unclipped part of the Clipped Surrogate Objective function","local":"the-unclipped-part-of-the-clipped-surrogate-objective-function","sections":[],"depth":2},{"title":"The clipped Part of the Clipped Surrogate Objective function","local":"the-clipped-part-of-the-clipped-surrogate-objective-function","sections":[],"depth":2}],"depth":1}';function ja(Ss){return Ma(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ia extends Ta{constructor(y){super(),ka(this,y,ja,Ca,xa,{})}}export{Ia as component};
